Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/Makefile.am	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,4 @@
 AM_LDFLAGS = $(CPPUNIT_LIBS) -ldl
 AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
-
-noinst_LIBRARIES = libMolecuilderActions.a
-libMolecuilderActions_a_SOURCES = ${ACTIONSSOURCE} ${ACTIONSHEADER}
 
 ACTIONSSOURCE = \
@@ -17,7 +14,9 @@
   ${MOLECULEACTIONSOURCE} \
   ${PARSERACTIONSOURCE} \
+  ${SELECTIONACTIONSOURCE} \
   ${TESSELATIONACTIONSOURCE} \
   ${WORLDACTIONSOURCE} \
-  MapOfActions.cpp
+  MapOfActions.cpp \
+  ValueStorage.cpp
 
 ACTIONSHEADER = \
@@ -28,7 +27,9 @@
   ${MOLECULEACTIONHEADER} \
   ${PARSERACTIONHEADER} \
+  ${SELECTIONACTIONHEADER} \
   ${TESSELATIONACTIONHEADER} \
   ${WORLDACTIONHEADER} \
   MapOfActions.hpp \
+  ValueStorage.hpp \
   Values.hpp
   
@@ -36,18 +37,26 @@
   AnalysisAction/MolecularVolumeAction.cpp \
   AnalysisAction/PairCorrelationAction.cpp \
-  AnalysisAction/PrincipalAxisSystemAction.cpp
+  AnalysisAction/PointCorrelationAction.cpp \
+  AnalysisAction/PrincipalAxisSystemAction.cpp \
+  AnalysisAction/SurfaceCorrelationAction.cpp
 ANALYSISACTIONHEADER = \
   AnalysisAction/MolecularVolumeAction.hpp \
   AnalysisAction/PairCorrelationAction.hpp \
-  AnalysisAction/PrincipalAxisSystemAction.hpp
+  AnalysisAction/PointCorrelationAction.hpp \
+  AnalysisAction/PrincipalAxisSystemAction.hpp \
+  AnalysisAction/SurfaceCorrelationAction.hpp
 
 ATOMACTIONSOURCE = \
   AtomAction/AddAction.cpp \
   AtomAction/ChangeElementAction.cpp \
-  AtomAction/RemoveAction.cpp
+  AtomAction/RemoveAction.cpp \
+  AtomAction/RotateAroundOriginByAngleAction.cpp \
+  AtomAction/TranslateAction.cpp
 ATOMACTIONHEADER = \
   AtomAction/AddAction.hpp \
   AtomAction/ChangeElementAction.hpp \
-  AtomAction/RemoveAction.cpp
+  AtomAction/RemoveAction.cpp \
+  AtomAction/RotateAroundOriginByAngleAction.hpp \
+  AtomAction/TranslateAction.hpp
 
 CMDACTIONSOURCE = \
@@ -80,4 +89,5 @@
   MoleculeAction/FillWithMoleculeAction.cpp \
   MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp \
+  MoleculeAction/RotateAroundSelfByAngleAction.cpp \
   MoleculeAction/RotateToPrincipalAxisSystemAction.cpp \
   MoleculeAction/SaveAdjacencyAction.cpp \
@@ -85,5 +95,4 @@
   MoleculeAction/SaveTemperatureAction.cpp \
   MoleculeAction/SuspendInWaterAction.cpp \
-  MoleculeAction/TranslateAction.cpp \
   MoleculeAction/VerletIntegrationAction.cpp
 MOLECULEACTIONHEADER = \
@@ -92,4 +101,5 @@
   MoleculeAction/FillWithMoleculeAction.hpp \
   MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp \
+  MoleculeAction/RotateAroundSelfByAngleAction.hpp \
   MoleculeAction/RotateToPrincipalAxisSystemAction.hpp \
   MoleculeAction/SaveAdjacencyAction.hpp \
@@ -97,5 +107,4 @@
   MoleculeAction/SaveTemperatureAction.hpp \
   MoleculeAction/SuspendInWaterAction.hpp \
-  MoleculeAction/TranslateAction.hpp \
   MoleculeAction/VerletIntegrationAction.hpp
                  
@@ -107,4 +116,51 @@
   ParserAction/SaveXyzAction.hpp
 
+SELECTIONACTIONSOURCE = \
+	SelectionAction/AllAtomsAction.cpp \
+	SelectionAction/AllAtomsInsideCuboidAction.cpp \
+	SelectionAction/AllAtomsInsideSphereAction.cpp \
+	SelectionAction/AllAtomsOfMoleculeAction.cpp \
+	SelectionAction/AllMoleculesAction.cpp \
+	SelectionAction/AtomByElementAction.cpp \
+	SelectionAction/AtomByIdAction.cpp \
+	SelectionAction/ClearAllAtomsAction.cpp \
+	SelectionAction/ClearAllMoleculesAction.cpp \
+	SelectionAction/MoleculeByFormulaAction.cpp \
+	SelectionAction/MoleculeByIdAction.cpp \
+	SelectionAction/MoleculeOfAtomAction.cpp \
+	SelectionAction/NotAllAtomsAction.cpp \
+	SelectionAction/NotAllAtomsInsideCuboidAction.cpp \
+	SelectionAction/NotAllAtomsInsideSphereAction.cpp \
+	SelectionAction/NotAllAtomsOfMoleculeAction.cpp \
+	SelectionAction/NotAllMoleculesAction.cpp \
+	SelectionAction/NotAtomByElementAction.cpp \
+	SelectionAction/NotAtomByIdAction.cpp \
+	SelectionAction/NotMoleculeByFormulaAction.cpp \
+	SelectionAction/NotMoleculeByIdAction.cpp \
+	SelectionAction/NotMoleculeOfAtomAction.cpp
+SELECTIONACTIONHEADER = \
+	SelectionAction/AllAtomsAction.hpp \
+	SelectionAction/AllAtomsInsideCuboidAction.hpp \
+	SelectionAction/AllAtomsInsideSphereAction.hpp \
+	SelectionAction/AllAtomsOfMoleculeAction.hpp \
+	SelectionAction/AllMoleculesAction.hpp \
+	SelectionAction/AtomByElementAction.hpp \
+	SelectionAction/AtomByIdAction.hpp \
+	SelectionAction/ClearAllAtomsAction.hpp \
+	SelectionAction/ClearAllMoleculesAction.hpp \
+	SelectionAction/MoleculeByFormulaAction.hpp \
+	SelectionAction/MoleculeByIdAction.hpp \
+	SelectionAction/MoleculeOfAtomAction.hpp \
+	SelectionAction/NotAllAtomsAction.hpp \
+	SelectionAction/NotAllAtomsInsideCuboidAction.hpp \
+	SelectionAction/NotAllAtomsInsideSphereAction.hpp \
+	SelectionAction/NotAllAtomsOfMoleculeAction.hpp \
+	SelectionAction/NotAllMoleculesAction.hpp \
+	SelectionAction/NotAtomByElementAction.hpp \
+	SelectionAction/NotAtomByIdAction.hpp \
+	SelectionAction/NotMoleculeByFormulaAction.hpp \
+	SelectionAction/NotMoleculeByIdAction.hpp \
+	SelectionAction/NotMoleculeOfAtomAction.cpp
+
 TESSELATIONACTIONSOURCE = \
   TesselationAction/ConvexEnvelopeAction.cpp \
@@ -122,5 +178,4 @@
   WorldAction/InputAction.cpp \
   WorldAction/OutputAction.cpp \
-  WorldAction/RemoveSphereOfAtomsAction.cpp \
   WorldAction/RepeatBoxAction.cpp \
   WorldAction/ScaleBoxAction.cpp \
@@ -136,5 +191,4 @@
   WorldAction/InputAction.hpp \
   WorldAction/OutputAction.hpp \
-  WorldAction/RemoveSphereOfAtomsAction.hpp \
   WorldAction/RepeatBoxAction.hpp \
   WorldAction/ScaleBoxAction.hpp \
@@ -143,2 +197,51 @@
   WorldAction/SetOutputFormatsAction.hpp               
 
+
+lib_LTLIBRARIES = libMolecuilderActions-@MOLECUILDER_API_VERSION@.la
+libMolecuilderActions_includedir = $(includedir)/molecuilder-$(MOLECUILDER_API_VERSION)/Actions/
+libMolecuilderActions_libs = ../Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la
+nobase_libMolecuilderActions_include_HEADERS = ${ACTIONSHEADER}
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libMolecuilderActions_@MOLECUILDER_API_VERSION@_la_SOURCES = ${ACTIONSSOURCE}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+libMolecuilderActions_@MOLECUILDER_API_VERSION@_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libMolecuilderActions_libincludedir = $(libdir)/molecuilder-$(MOLECUILDER_API_VERSION)/include
+nodist_libMolecuilderActions_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
+
+## Install the generated pkg-config file (.pc) into the expected location for
+## architecture-dependent package configuration information.  Occasionally,
+## pkg-config files are also used for architecture-independent data packages,
+## in which case the correct install location would be $(datadir)/pkgconfig.
+pkgconfigdir = $(libdir)/pkgconfig
+pkgconfig_DATA = $(top_builddir)/molecuilder-$(MOLECUILDER_API_VERSION).pc
+
+unity.cpp:
+	echo "" >  unity.cpp; \
+	list='$(ACTIONSSOURCE)'; for file in $$list; do \
+	  echo "#include \"$(srcdir)/$$file\"" >> unity.cpp; \
+	done;
+	
+MOSTLYCLEANFILES = unity.cpp
Index: src/Actions/MakroAction.cpp
===================================================================
--- src/Actions/MakroAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MakroAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -44,4 +49,7 @@
 }
 
+Dialog* MakroAction::fillDialog(Dialog *dialog) {
+  return actions->fillAllDialogs(dialog);
+}
 
 Action::state_ptr MakroAction::performCall(){
Index: src/Actions/MakroAction.hpp
===================================================================
--- src/Actions/MakroAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MakroAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -29,4 +29,6 @@
   bool shouldUndo();
 
+protected:
+  virtual Dialog *fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/ManipulateAtomsProcess.cpp
===================================================================
--- src/Actions/ManipulateAtomsProcess.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ManipulateAtomsProcess.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -26,4 +31,9 @@
 ManipulateAtomsProcess::~ManipulateAtomsProcess()
 {}
+
+Dialog* ManipulateAtomsProcess::fillDialog(Dialog *dialog){
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+  return dialog;
+}
 
 Action::state_ptr ManipulateAtomsProcess::performCall(){
@@ -53,5 +63,9 @@
   setMaxSteps(world->numAtoms());
   start();
-  for(World::AtomIterator iter=world->getAtomIter(descr);iter!=world->atomEnd();++iter){
+  for(World::internal_AtomIterator
+      iter=world->getAtomIter_internal(descr);
+      iter!=world->atomEnd_internal();
+      ++iter){
+
     setCurrStep(iter.getCount());
     operation(*iter);
Index: src/Actions/ManipulateAtomsProcess.hpp
===================================================================
--- src/Actions/ManipulateAtomsProcess.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ManipulateAtomsProcess.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -27,6 +27,8 @@
 
   virtual void doManipulate(World *);
+
+protected:
+  virtual Dialog * fillDialog(Dialog*);
 private:
-
   virtual Action::state_ptr performCall();
   virtual Action::state_ptr performUndo(Action::state_ptr);
